# mypy-boto3-lex-runtime

[![PyPI - mypy-boto3-lex-runtime](https://img.shields.io/pypi/v/mypy-boto3-lex-runtime.svg?color=blue)](https://pypi.org/project/mypy-boto3-lex-runtime)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-lex-runtime.svg?color=blue)](https://pypi.org/project/mypy-boto3-lex-runtime)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.LexRuntimeService 1.16.5](https://boto3.amazonaws.com/v1/documentation/api/1.16.5/reference/services/lex-runtime.html#LexRuntimeService) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 3.2.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-lex-runtime](#mypy-boto3-lex-runtime)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `LexRuntimeService` service.

```bash
python -m pip install boto3-stubs[lex-runtime]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[lex-runtime]` in your environment: `python -m pip install 'boto3-stubs[lex-runtime]'`

Both type checking and auto-complete should work for `LexRuntimeService` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[lex-runtime]` in your environment: `python -m pip install 'boto3-stubs[lex-runtime]'`

Both type checking and auto-complete should work for `LexRuntimeService` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[lex-runtime]` in your environment: `python -m pip install 'boto3-stubs[lex-runtime]'`
- Run `mypy` as usual

Type checking should work for `LexRuntimeService` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[lex-runtime]` in your environment: `python -m pip install 'boto3-stubs[lex-runtime]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `LexRuntimeService` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`LexRuntimeServiceClient` provides annotations for `boto3.client("lex-runtime")`.

```python
import boto3

from mypy_boto3_lex_runtime import LexRuntimeServiceClient

client: LexRuntimeServiceClient = boto3.client("lex-runtime")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: LexRuntimeServiceClient = session.client("lex-runtime")
```








### Typed dictionations

`mypy_boto3_lex_runtime.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_lex_runtime.type_defs import (
    ButtonTypeDef,
    DeleteSessionResponseTypeDef,
    DialogActionTypeDef,
    GenericAttachmentTypeDef,
    GetSessionResponseTypeDef,
    IntentConfidenceTypeDef,
    IntentSummaryTypeDef,
    PostContentResponseTypeDef,
    PostTextResponseTypeDef,
    PredictedIntentTypeDef,
    PutSessionResponseTypeDef,
    ResponseCardTypeDef,
    SentimentResponseTypeDef,
)

def get_structure() -> ButtonTypeDef:
    return {
      ...
    }
```
